<template>
  <div class="star-rating">
    <template v-if="!editMode">
      <div v-for="(item, index) in ratingList" :key="index">
        <svg v-if="item" :width="starSize" :height="starSize" viewBox="0 0 10 10" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path fill-rule="evenodd" clip-rule="evenodd" d="M4.72256 7.80821L2.45747 8.99076C2.09045 9.18237 1.6629 8.87042 1.73336 8.46243L2.16505 5.963L0.339604 4.19599C0.0410947 3.90704 0.204757 3.4012 0.61595 3.34186L3.14193 2.97737L4.27481 0.697874C4.45867 0.327909 4.98644 0.327908 5.17031 0.697874L6.30319 2.97737L8.82917 3.34186C9.24036 3.4012 9.40402 3.90704 9.10551 4.196L7.28007 5.963L7.71176 8.46243C7.78222 8.87042 7.35467 9.18237 6.98765 8.99076L4.72256 7.80821Z" fill="#FFBA49"/>
        </svg>
        <svg v-if="!item" :width="starSize" :height="starSize" viewBox="0 0 11 11" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path fill-rule="evenodd" clip-rule="evenodd" d="M5.77249 8.80821L3.50739 9.99076C3.14038 10.1824 2.71282 9.87042 2.78329 9.46243L3.21498 6.963L1.38953 5.19599C1.09102 4.90704 1.25468 4.4012 1.66588 4.34186L4.19186 3.97737L5.32473 1.69787C5.5086 1.32791 6.03637 1.32791 6.22024 1.69787L7.35311 3.97737L9.87909 4.34186C10.2903 4.4012 10.4539 4.90704 10.1554 5.196L8.32999 6.963L8.76168 9.46243C8.83215 9.87042 8.40459 10.1824 8.03758 9.99076L5.77249 8.80821Z" stroke="#9B9B9B"/>
        </svg>
      </div>
    </template>
    <div id="h" v-if="editMode" @mouseout="mouseOver(0)" :style="{ 'display': 'block', height: '20px' }">
      <span v-for="(item, index) in 5" :key="index" :style="{ 'padding-right': '4px' }">
        <span v-if="rating < index" @mouseover="mouseOver(index + 1)" @click="ratingClicked(index)">
          <svg v-if="currentHover <= (index)" :width="Number(starSize)" :height="starSize" xmlns="http://www.w3.org/2000/svg" id="Layer_1" data-name="Layer 1" viewBox="0 0 512 512">
            <title>star-outline</title><path class="cls-1" fill="#9B9B9B" d="M405.33,512a21.32,21.32,0,0,1-12.4-4L256,410.21,119.07,508A21.34,21.34,0,0,1,86,485.48l39.74-158.95L6.25,207.08a21.33,21.33,0,0,1,15.08-36.42H177.21L236,13.84a21.33,21.33,0,0,1,39.95,0l58.81,156.82H490.67a21.33,21.33,0,0,1,15.08,36.42L386.29,326.54,426,485.48A21.33,21.33,0,0,1,405.33,512ZM256,362.66a21.33,21.33,0,0,1,12.4,4l102.18,73L342,325.17a21.33,21.33,0,0,1,5.61-20.26l91.58-91.58H320a21.34,21.34,0,0,1-20-13.84L256,82.09,212,199.49a21.34,21.34,0,0,1-20,13.84H72.84l91.58,91.58A21.33,21.33,0,0,1,170,325.17L141.42,439.62l102.18-73A21.33,21.33,0,0,1,256,362.66Z"/>
          </svg>
          <svg v-else :width="Number(starSize)" :height="starSize" xmlns="http://www.w3.org/2000/svg" id="Layer_1" data-name="Layer 1" viewBox="0 0 512 512">
            <title>star-outline</title><path class="cls-1"  d="M405.33,512a21.32,21.32,0,0,1-12.4-4L256,410.21,119.07,508A21.34,21.34,0,0,1,86,485.48l39.74-158.95L6.25,207.08a21.33,21.33,0,0,1,15.08-36.42H177.21L236,13.84a21.33,21.33,0,0,1,39.95,0l58.81,156.82H490.67a21.33,21.33,0,0,1,15.08,36.42L386.29,326.54,426,485.48A21.33,21.33,0,0,1,405.33,512ZM256,362.66a21.33,21.33,0,0,1,12.4,4l102.18,73L342,325.17a21.33,21.33,0,0,1,5.61-20.26l91.58-91.58H320a21.34,21.34,0,0,1-20-13.84L256,82.09,212,199.49a21.34,21.34,0,0,1-20,13.84H72.84l91.58,91.58A21.33,21.33,0,0,1,170,325.17L141.42,439.62l102.18-73A21.33,21.33,0,0,1,256,362.66Z"/>
          </svg>
        </span>
        <span v-else @click="ratingClicked(index)" @mouseover="mouseOver(index + 1)">
          <svg v-if="currentHover <= (index)" :width="Number(starSize)" :height="starSize" xmlns="http://www.w3.org/2000/svg" id="Layer_1" data-name="Layer 1" viewBox="0 0 512 512">
            <title>star-glyph</title><path fill="#FFBA49" d="M510.37,183.83a21.33,21.33,0,0,0-19.71-13.17H334.79L276,13.84a21.33,21.33,0,0,0-39.95,0L177.21,170.66H21.33A21.33,21.33,0,0,0,6.25,207.08L125.71,326.54,86,485.48A21.34,21.34,0,0,0,119.07,508L256,410.21,392.93,508A21.34,21.34,0,0,0,426,485.48L386.29,326.54,505.75,207.08A21.33,21.33,0,0,0,510.37,183.83Z"/>
          </svg>
          <svg v-else :width="Number(starSize)" :height="starSize" xmlns="http://www.w3.org/2000/svg" id="Layer_1" data-name="Layer 1" viewBox="0 0 512 512">
            <title>star-glyph</title><path fill="#F59700" d="M510.37,183.83a21.33,21.33,0,0,0-19.71-13.17H334.79L276,13.84a21.33,21.33,0,0,0-39.95,0L177.21,170.66H21.33A21.33,21.33,0,0,0,6.25,207.08L125.71,326.54,86,485.48A21.34,21.34,0,0,0,119.07,508L256,410.21,392.93,508A21.34,21.34,0,0,0,426,485.48L386.29,326.54,505.75,207.08A21.33,21.33,0,0,0,510.37,183.83Z"/>
          </svg>
        </span>
      </span>
    </div>
  </div>
</template>
<script>
export default {
  name: 'StarRating',
  props: {
    rating: {
      type: Number,
      default: 3
    },
    starSize: {
      type: [String, Number],
      default: '13'
    },
    editMode: {
      type: Boolean,
      default: false
    }
  },
  data: () => ({
    currentHover: 0
  }),
  computed: {
    ratingList () {
      const list = [false, false, false, false, false]
      for (let i = 0; i < this.rating; i++) {
        list[i] = true
      }
      return list
    }
  },
  methods: {
    mouseOver (index) {
      this.currentHover = index
    },
    ratingClicked (index) {
      this.$emit('amount-change', index)
    }
  }
}
</script>
<style lang="scss" scoped>
.star-rating {
  display: flex;
  div:not(:first-child) {
    margin-left: 6px;
  }
  & > div {
    height: 10px;
  }
}
</style>
